//FFSubmenu=Exif
//FFName=Saver, Exif ndern V3.8
//FFPath=saver3.js

/*********************************************************
' Saver.js v3.8
' (C) Heinz Hfling 15.07.2004
' Email: fixfoto@gmx.de
'
' ablauffhig ab Fixfoto V2.76 B:49
' Fixfoto: http://www.j-k-s.com
'
' Weitere Informationen in ..\srcipt\saver3.html
'
' Dieses Script erhebt nicht den Anspruch der neusten
' JavaScript Programiertechnik zu entsprechen.
' Also,
' wenn etwas nicht gefllt, ich bin fr Verbesserungsvorschlge offen.
' nderungen:
' 16.7.2004 V3.2
' - Fehlermeldung wenn kein Bild geladen.
' - Sucht saver3.html im gleichen Verzeichniss wie das Script
' - Options dialog aktualliesiert Hauptdialog
' - Model-Tag immer sichtbar.
' - Bessere Fehlerprfung.
' - Exif kann angelegt werden, (aber Bild muss schon als Datei existieren!)
' 16.7.2004 V3.3
' - Einzeilige Edit Felder mit SLEDIT stat EDIT Control.
' 19.7.2004 V3.4
' - Showhelp warte nicht auf Ende der Hilfe.
' 08.8.2004 V3.5
' - Copyright wird eingetragen wenn Feld leer ist.
' - Zwecks erweiterter EXIF Editierung kann nach dem Anlegen eines Exifblocks
'   oder mit dem Knopf "Weitere EXIF..." aus dem Hauptdialog ein zweites Script
'   aufgerufen werden, das die EXIF Daten im Speicher vernder. Abspeicher
'   sollte dieses Script die Exif Daten nicht! da dies hier erfolgt.
'   Das Script wird mit dem Paramter "filename -NOSAVE" aufgerufen.
' - Aufgerumt, Control und Dialog Klasse erweitert.
' - Copyright2 hinzugefgt.
' 21.08.2004 V3.6
' - Bercksichtig neuen Aufrufparameter(ab 2.76B78).
' - Fehler bereinigt, der bei der Einstellung "in Zielpfad wechseln=NEIN" zu
'   Speicherung im falschen Bild fhrte.
' 27.08.2004 V3.7
' - Default Knopf fr Copyright2 (identisch mit 1), Auto-Defaultwert wie bei 1
' - Script nur fr Exif verwenden (abschaltbar), zum wiedereinschalten JPG speichern!
' 02.02.2005 V3.8
' - Model-Tag nach Extension-Script aktualiesieren
'*********************************************************/



//----------------------------------------------------------------
// Hauptprogramm
//----------------------------------------------------------------
// Diese Variablen werden in der Registry aufbewahrt.
var C_Artist = "";
var C_Copyr  = "";
var C_Models = "";
var C_ResentSize="";
var C_EditExifScript ="";
var C_OnlyJpg  ="0";

var args =FF_GetParam().split("\r\n");
var CKF = args[0];
var CPA = (args[1]==undefined) ? "" : args[1];
var fso = new ActiveXObject("Scripting.FileSystemObject");
var name;

//Debug-Module------------
var debuger=null;
function Outdebug(s)
{  if (debuger!=null) debuger.Outdebug(s); 
}
try { var debuger = new ActiveXObject("ComDbg.ComDebugD7"); 
      Outdebug("Script startet");
    }
catch(e) {}
//Debug-Module------------




var ff  = eval(FF_GetMajor() + "." + FF_GetMinor()) // -0.10;
if( (ff <2.76) || ((ff==2.76)&&(FF_GetBuild()<49)) )
{
 FF_ErrorBreak("Die Version muss mindestens 2.76 B49 sein");
}
else
{
 name = FF_GetImageName(-1);  // immer "Bearbeitungsbild"
 if( CPA != "" )
      name = CPA;
 if ( name == "")
   FF_ErrorBreak("Kein Bild zur Bearbeitung geladen!");
 else
  {
   ReadINI();
   if( C_OnlyJpg > 0)
    if( name.match(/\.jpg/i , name)==null && name.match(/\.jpeg/i, name)==null )
       name = "";
   if( name!="")  
    {
     if( FF_HasExif() || MakeExif()==1)
     {
      if( FF_HasExif() )
       {
        //if(FF_LoadExif(name))
         {
          StartDialog();
         } // else FF_MessageBox("Fehler bei FF_LoadExif!\r\nDas Bild enthlt keine EXIF Daten!",0);
       } else FF_MessageBox("Das Bild enthlt keine EXIF Daten!",0);
      } // no exif no create
     } // no name
   }  
 }

//----------------------------------------------------------------
//-- Subroutines ----
//----------------------------------------------------------------

function GenDefaultCpy(aArtist)
{
// Default Copyright-Jahr aufbauen aus Bilddatum
 var dcpy;

 if( C_Copyr == "" )
  {
    var date = FF_GetExifTag("DateTime");
    if(date == "") date = FF_GetExifTag("DateTimeOriginal");
    if(date == "") date = FF_GetExifTag("DateTimeDigitized");
    if(date != "")
        dcpy = " " + (date.split(" ")[0]).split(":")[0] + " " + aArtist;
     else 
        dcpy = " " + aArtist;
   } else dcpy = C_Copyr;
 return dcpy;
}

function GetArtist()
{
// EXIF Feld Autor auslesen
   var aArtist = FF_GetExifTag("Artist");
   if( aArtist == "" )
       aArtist = C_Artist;       // Default verwenden
   //Outdebug("GetArtist:"+aArtist);
   return aArtist;
}  
function GetCopyr2(tag,dcpy)
{
// Default Copyright einsetzen falls keines da ist
   var cpy = FF_GetExifTag(tag);
   if( cpy == "" )
       cpy = dcpy; 
  return cpy;
}

function GetSoftw()
{
// Bisheriges Sofware Tag auslesen        
  var soft = FF_GetExifTag("Software");
  soft = soft.replace(/\r\n\r\n/g,"\r\n");  // Leerzeilen entfernen
  softs = soft.split("\r\n");				  // in Array wandeln
// Ist FixFoto schon eingetragen ?    
  var ffs  = "FixFoto V" + FF_GetMajor() + "." + FF_GetMinor() + " B:" + FF_GetBuild();
   if ( softs[0].indexOf("FixFoto V",0) < 0 )
     {
      soft = ffs + "\r\n" + soft;    // FixFoto... vorne einfuegen
      softs = soft.split("\r\n");	 // neu aufteilen
     }  else softs[0] = ffs; 		 // FixFoto in Zeile 1 berschreiben mit aktueller Version
// softs[0] ist nun definitiv "FixFoto..."
    soft = softs.join("\r\n");
 return soft;
}


function StartDialog() 
{
 var r;
 var DlgName, CtrlTop, LabelOffset, LeftOffset, CtrlHght;
 var dcpy;
 var WS_VSCROLL = 0x200000;

// mit diesen Werten nun den Dialog aufbauen
    
    CtrlTop = 3;
    LeftOffset  = 5;
    LabelOffset = 40;
    CtrlHght    = 9;
    dlgh = 135+10;
    MDlg = new Dialog("Exif ndern V3,  Datei: "+ name+" "+ CKF , 300,dlgh);
         MDlg.addControl("Artist:", "STATIC", LeftOffset,  CtrlTop, LabelOffset-LeftOffset, CtrlHght,0);
eArtist= MDlg.addControl("eArtist", "SLEDIT",      LabelOffset, CtrlTop, 200, CtrlHght,0);
bArtist= MDlg.addControl("Default Ar&tist","BUTTON", LabelOffset+200+5,CtrlTop,50,CtrlHght,0);
CtrlTop+=10;
         MDlg.addControl("Copyright:","STATIC",LeftOffset, CtrlTop, LabelOffset-LeftOffset, CtrlHght);
eCoypr1= MDlg.addControl("eCoypr1", "SLEDIT",  LabelOffset, CtrlTop, 200, CtrlHght);
bCopyr1= MDlg.addControl("Default &Copyr.","BUTTON", LabelOffset+200+5,CtrlTop,50,CtrlHght);
CtrlTop+=10;
         MDlg.addControl("Copyright2:","STATIC",LeftOffset, CtrlTop, LabelOffset-LeftOffset, CtrlHght);
eCoypr2= MDlg.addControl("eCoypr2", "SLEDIT",  LabelOffset, CtrlTop, 200, CtrlHght);
bCopyr2= MDlg.addControl("Default &Copyr2.","BUTTON", LabelOffset+200+5,CtrlTop,50,CtrlHght);
CtrlTop+=10;
         MDlg.addControl("Kommentar:","STATIC",LeftOffset, CtrlTop-2, LabelOffset-LeftOffset, CtrlHght);
eKomm =  MDlg.addControl("eKomm", "EDIT",   LabelOffset, CtrlTop, 255, CtrlHght * 5 , WS_VSCROLL);
         MDlg.addControl("(History-LOG)","STATIC",LeftOffset, CtrlTop+CtrlHght-4, LabelOffset-LeftOffset, CtrlHght);
iImage1= MDlg.addControl("iImage1","IMAGE",LeftOffset-2, CtrlTop+CtrlHght+CtrlHght-6, LabelOffset-LeftOffset, CtrlHght*4-3);
CtrlTop+=(CtrlHght * 5)+1;
         MDlg.addControl("Software:","STATIC",LeftOffset, CtrlTop, LabelOffset-LeftOffset, CtrlHght);
eSoftw = MDlg.addControl("eSoftw", "EDIT",   LabelOffset, CtrlTop, 255, CtrlHght * 2 , WS_VSCROLL);
CtrlTop+=(CtrlHght * 2)+1;
         MDlg.addControl("Beschreibung:","STATIC",LeftOffset, CtrlTop, LabelOffset-LeftOffset, CtrlHght);
eBeschr = MDlg.addControl("eBeschr", "EDIT",   LabelOffset, CtrlTop, 255, CtrlHght * 2 , WS_VSCROLL);
CtrlTop+=(CtrlHght * 2)+1;
         MDlg.addControl("Model:","STATIC",LeftOffset, CtrlTop, LabelOffset-LeftOffset, CtrlHght);
eModel = MDlg.addControl("eModel", "SLEDIT",   LabelOffset, CtrlTop, 95, CtrlHght );
cModel = MDlg.addControl("cModel", "COMBO",   LabelOffset+100, CtrlTop, 95, CtrlHght-1 );

CtrlTop+=(CtrlHght * 1)+4;
         MDlg.addControl(" H.Hfling","STATIC",LeftOffset, CtrlTop, LabelOffset, CtrlHght+2);
opts    =MDlg.addControl("&Options",   "BUTTON", LabelOffset, CtrlTop+1, 30, CtrlHght);
         MDlg.addControl("Bilderliste mitfhren:","STATIC",LabelOffset+35, CtrlTop, 100, CtrlHght+2);
cBildList=MDlg.addControl("cBildList", "BOOL",   LabelOffset+35+50, CtrlTop, 20, CtrlHght+2 );
help   = MDlg.addControl("&Hilfe!",     "BUTTON", LabelOffset+35+50+20, CtrlTop+1, 30, CtrlHght);
bExtend= MDlg.addControl("&Erweitert...", "BUTTON", LabelOffset+35+50+20+35, CtrlTop, 40, CtrlHght+2);
abort  = MDlg.addControl("&Abbruch",   "BUTTON", 230, CtrlTop, 30, CtrlHght+2);
ok     = MDlg.addControl("&Speichern", "BUTTON", 265, CtrlTop, 30, CtrlHght+2);



// Dialog erzeugt
   iImage1.Set(0);

   eArtist.Set(GetArtist());
   dcpy = GenDefaultCpy(GetArtist());
   eCoypr1.Set( GetCopyr2("Copyright1",dcpy) );
   eCoypr2.Set( GetCopyr2("Copyright2","") );
   eSoftw.Set(GetSoftw());

// History auslesen, und crlf in ";" wandeln
// hierbei den Schritt "Scripte" auslassen, dieses Script selbst in der History erscheint
    var log = FF_GetHistory();
    log = log.replace(/ \r\n/g,"\r\n");     // hngende Blanks weg
    log = log.replace(/\r\n$/,"");          // abschliesendes CR entfernen
    log = log.replace(/\r\n/g,"; ");        // crlf in "; "
    log = log.replace(/; Skripte; /g,"; "); // "Scripte" in der Mitte entfernen
    log = log.replace(/Skripte; /g,"");     // "Scripte" am Anfang entfernen
    log = log.replace(/; Skripte/g,"");	    // "Scripte" am Ende entfernen
    log = log.replace(/Skripte/g,"");	    // das Wort "Scripte" entfernen

// Bisheriges Kommentar Tag auslesen
    var comm = FF_GetExifTag("UserComment");
    comm = comm.replace(/\r\n\r\n/g,"\r\n");  // doppel CR entfernen
    comm = comm.replace(/^\r\n/,"");          // fuerendes CR entfernen
    if( CKF != "")
       comm = comm.replace(/KF:0[0-9]*/,"");  // KF:0xx<cr> entfernen
    comm = comm.replace(/\r\n$/,"");          // abschliesendes CR entfernen
// nun nachschauen ob aktuelles Log schon drin ist
    if( log != "")
      if ( ("\r\n"+comm+"\r\n").indexOf("\r\n"+log+"\r\n")  <0  )
       {
        if ( comm != "") comm +=  "\r\n";
        comm += log;  // log anhngen
       }

    if( CKF != "")
      {
        if ( comm != "") comm +=  "\r\n";
        comm += "KF:0"+CKF;               // neuen KF: ablegen
      }
    eKomm.Set( comm);
    eBeschr.Set( FF_GetExifTag("ImageDescription") );
    eModel.Set( FF_GetExifTag("Model") );
    cBildList.Set( CUpdateBilderListe);

 for(;;)
 {
    MDlg.Enable(bExtend,(C_EditExifScript!=""));
    cModel.SetComboFromListe(C_Models,FF_GetExifTag("Model"));  // erst hier, da von Options verndert
    MDlg.Activate(eBeschr);
    r = MDlg.Show();
    switch(r)
    {
     case bArtist.name : eArtist.Set(C_Artist);
                         dcpy=GenDefaultCpy(C_Artist);
                         break;
     case bCopyr1.name :eCoypr1.Set(dcpy);
                        break;
     case bCopyr2.name :eCoypr2.Set(dcpy);
                        break;
     case cModel.name:  eModel.Set(cModel.Get());
                        break;
     case opts.name  :  Options();
                        ReadINI();
                        dcpy = GenDefaultCpy(eArtist.Get());
                        break;
     case bExtend.name: var sp=FF_getParam();
                        FF_SetParam( escape(name) +" -NOSAVE");
                        ff_CallScript(C_EditExifScript);
                        FF_SetParam(sp);
                        eModel.Set( FF_GetExifTag("Model") );
                        break;
     case help.name:    ShowHelp();
                        break;
     default:           break;
    } // switch
  if( (r == "CANCEL") || (r == abort.name) || (r == ok.name) )
      break;
 } // for

// Einstellungen Schalter auch bei Abbruch "merken"
    CUpdateBilderListe = cBildList.Get();
    FF_WriteProfile("Saverv3","UpdateBilderliste",CUpdateBilderListe);

// Dialogende, verarbeiten
    if ( r == ok.name )
     {
     var dirty = 0;
     dirty += eArtist.UpdateExifSimple("Artist");
     dirty += eCoypr1.UpdateExifSimple("Copyright1");
     dirty += eCoypr2.UpdateExifSimple("Copyright2");
     dirty += eKomm.UpdateExifML("UserComment");
     dirty += eSoftw.UpdateExifML("Software");
     dirty += eBeschr.UpdateExifML("ImageDescription");
     dirty += eModel.UpdateExifSimple("Model");
     if ( dirty > 0 )
       {
        //FF_MessageBox("Now Save_Exif:"+name ,0);
        FF_SaveExif(name);
        FF_reload();
       }
      if( (cBildList.Get()=="1") && (CBilderListenname!="") )
      {
       if (FF_IListCreate(CBilderListenname) )
        {
         FF_IListDeleteFile(CBilderListenname,name);
         FF_IListInsertFile(CBilderListenname,name,-1);
         // Behalte die letzen X Eintrge
         while (FF_IListGetCount(CBilderListenname) > C_ResentSize )
         {
           if( !FF_IListDeleteIndex(CBilderListenname,0) )
            break;
         }
         FF_IListSave(CBilderListenname);
        }
      }
    }
  MDlg.Close();
}

function Dialog(name,w,h)
{
 this.dlgname = name;
 FF_AddDialog(this.dlgname, w,h);

 this.Show   = function()
   { var r =FF_ShowDialog(this.dlgname);
    //ff_MessageBox("DlgEnde "+this.dlgname+":<"+r+">",1);
    return r;
   }
 this.Close  = function()
   { FF_CloseDialog(this.dlgname); }
 this.Enable = function(delem,flag)
   {
     Outdebug("Enable:"+this.dlgname+" "+delem.name+" "+flag); 
     FF_EnableControl(this.dlgname,delem.name,flag); 
    }
 this.Activate = function(delem)
   { FF_ActivateControl(this.dlgname,delem.name); }
 this.addControl = function (ename,type,x,y,w,h,style)
  { return new Control(this.dlgname,ename,type,x,y,w,h,style) }
}

function Control(dlgname,name,type,x,y,w,h,style)
{
   this.DlgName = dlgname;
   this.name = name;
   if (name!="")
   {
    FF_AddControl(this.DlgName,name,type,x,y,w,h);
    if(style != 0) FF_SetControlStyle(this.DlgName,name,style);
   }
   this.Set = function(val)
      {
      //FF_MessageBox(this.DlgName+"."+this.name+"="+val,1);
      FF_SetControl(this.DlgName,this.name,val);
      }
   this.Get = function()
      {return FF_GetControl(this.DlgName,this.name);}
   this.GetML = function()
      {
       var newv = FF_GetControl(this.DlgName,this.name);
       newv = newv.replace(/\r\n\r\n/g,"\r\n");  // leerzeilen rausnehmen
       newv = newv.replace(/^\r\n/g,"");         // fhrendes cr rausnehmen
       return newv;
      }
   this.SetComboFromListe = function(liste,defaultv)
      {
      //ff_messageBox(liste + " " + defaultv,1);
      this.Set("");
      var elems = (liste+"").split("|");
      for( i=0; i<elems.length; i++)
      if (elems[i]!="")
         this.Set(elems[i]);
      if(defaultv!="")
       {
         this.Set(defaultv);
         this.Set(defaultv);
       }
      }
   this.UpdateExifSimple = function(ename)
      {
       var oldv = FF_GetExifTag(ename);
       var newv = this.Get();
       if ( oldv != newv)
        if ( FF_SetExifTag(ename,newv) )
          return 1;
       return 0;
      }
   this.UpdateExifML = function(ename) // Multiline line
      {
       var oldv = FF_GetExifTag(ename);
       var newv = this.GetML();
       if ( oldv != newv)
        if ( FF_SetExifTag(ename,newv) )
          return 1;
       return 0;
      }
}

function Options()
{
    var r;
    OCtrlTop = 3;
    OLeftOffset  = 5;
    OLabelOffset = 50;
    OCtrlHght    = 9;
    ODlg = new Dialog("Exif ndern V3, Optionen einstellen", 260,125);

         ODlg.addControl("Default Artist:", "STATIC", OLeftOffset, OCtrlTop, OLabelOffset-OLeftOffset, OCtrlHght);
    oe1 =ODlg.addControl("oe1", "SLEDIT",  OLabelOffset, OCtrlTop, 200, OCtrlHght);
    oe1.Set( C_Artist == "" ? "<not defined>" : C_Artist);
    OCtrlTop+=12-1;

         ODlg.addControl("Default Copyright1:", "STATIC", OLeftOffset, OCtrlTop, OLabelOffset-OLeftOffset, OCtrlHght);
    cp1 =ODlg.addControl("cp1", "SLEDIT",  OLabelOffset, OCtrlTop, 200, OCtrlHght);
    cp1.Set( C_Copyr=="" ? "<Automatisch>" : C_Copyr);
    OCtrlTop+=12-1;

         ODlg.addControl("Model-Tag:","STATIC",OLeftOffset, OCtrlTop, OLabelOffset-OLeftOffset, OCtrlHght);
    oe2 =ODlg.addControl("oe2", "EDIT",  OLabelOffset, OCtrlTop, 200, OCtrlHght*5, 0);
    var models =C_Models+"";
    if (models == "") models="<none>";
    oe2.Set( models.replace(/\|/g,"\r\n")  );
    OCtrlTop+=(OCtrlHght * 5)+2;

         ODlg.addControl("Bilderliste:", "STATIC", OLeftOffset, OCtrlTop, OLabelOffset-OLeftOffset, OCtrlHght);
    oe3 =ODlg.addControl("oe3", "SLEDIT",   OLabelOffset, OCtrlTop, 100, OCtrlHght , 0);
    oe3.Set(CBilderListenname);
    OCtrlTop+=12-1;

         ODlg.addControl("Anzahl Bilder:", "STATIC", OLeftOffset, OCtrlTop, OLabelOffset-OLeftOffset, OCtrlHght);
    oe4 =ODlg.addControl("oe4", "SLEDIT",   OLabelOffset, OCtrlTop, 30, OCtrlHght , 0);
         ODlg.addControl("Script nur fr JPG verwenden:", "STATIC", OLabelOffset+35, OCtrlTop, 72, OCtrlHght);
    oe4.Set(C_ResentSize);
    ocb4=ODlg.addControl("ocb4", "BOOL",    OLabelOffset+35+73, OCtrlTop, 30, OCtrlHght , 0);
    ocb4.Set(C_OnlyJpg);
    
    
    OCtrlTop+=12-1;

         ODlg.addControl("Edit Exif Script:", "STATIC", OLeftOffset,  OCtrlTop, OLabelOffset-OLeftOffset, OCtrlHght);
    e5 = ODlg.addControl("e5",   "SLEDIT",   OLabelOffset, OCtrlTop, 145, OCtrlHght , 0);
    e5.Set(C_EditExifScript);
    b5 = ODlg.addControl("Script auswhlen","BUTTON", OLabelOffset+145+5,OCtrlTop,50,OCtrlHght,0);
    OCtrlTop+=12-1;

    oabort=ODlg.addControl("&Abbruch",   "BUTTON", 185, OCtrlTop, 30, OCtrlHght+2,0);
    ook   =ODlg.addControl("&Speichern", "BUTTON", 220, OCtrlTop, 30, OCtrlHght+2,0);
    ODlg.Activate(oe1);

// Dialogschleife mit default-Knopf auswertung
    for(;;)
    {
     r =ODlg.Show();
     if( (r == "CANCEL") || (r == oabort.name) )
       break;
     if ( r == b5.name)
     {
        FF_SetCurrentPath(FF_GetScriptPath());
        pp=FF_EnterFileName(true, C_EditExifScript);
        if( (pp!="") && (pp!=undefined) )
         {
          C_EditExifScript=pp;
          e5.Set(pp);
         }
      r=""; // bleibe in der schleife
    }
// Dialogende, verarbeiten=
   if ( r == ook.name )
    {
     var autor =oe1.Get();
     FF_WriteProfile("Saverv3","EXIF_Artist",autor=="<not defined>" ? "" : autor);

     var cpr =cp1.Get();
     FF_WriteProfile("Saverv3","EXIF_Copyright1", cpr=="<Automatisch>" ? "" : cpr);

     var model=oe2.Get().replace(/\r\n/g,"|");
     FF_WriteProfile("Saverv3","EXIF_Models",model=="<none>" ? "" : model);

     bln=oe3.Get().replace(/\r\n/g,"");
     FF_WriteProfile("Saverv3","Bilderlistenname",bln);

     var b=ocb4.Get();
     FF_WriteProfile("Saverv3","EXIF_OnlyJpg",b);

     cl = oe4.Get();
     if( (cl<2) || (cl>100)  )
       {
        FF_MessageBox("Die gre der Bilderliste muss zwischen 2..100 liegen",0)
        cl = 30;
        r="";  // bleibe in schleife
        oe4.Set(cl);
       }
     FF_WriteProfile("Saverv3","CntBilderliste",cl);
     C_EditExifScript=e5.Get();
     FF_WriteProfile("Saverv3","EditExifScript",C_EditExifScript);
    } // Ok
    if (r != "") break;
  } // for
  ODlg.Close();
}


function ReadINI()
{
 C_OnlyJpg  = FF_GetProfile("Saverv3","EXIF_OnlyJpg");

 C_Artist = FF_GetProfile("Saverv3","EXIF_Artist");
 C_Models           = FF_GetProfile("Saverv3","EXIF_Models");
 CBilderListenname  = FF_GetProfile("Saverv3","Bilderlistenname");
 if ( CBilderListenname == "")  CBilderListenname="Bearbeitete Bilder";
 CUpdateBilderListe = FF_GetProfile("Saverv3","UpdateBilderliste");
 if( CUpdateBilderListe=="")    CUpdateBilderListe = "1";
 C_Copyr            = FF_GetProfile("Saverv3","EXIF_Copyright1");

 C_ResentSize=FF_GetProfile("Saverv3","CntBilderliste");
 if( (C_ResentSize<2) || (C_ResentSize>100)  )
    C_ResentSize="";
 if( C_ResentSize =="") C_ResentSize=30;  // default
 C_EditExifScript    = FF_GetProfile("Saverv3","EditExifScript");
}

function ShowHelp()
{
 var shell = new ActiveXObject("WScript.Shell");
// shell.Run("HH.exe "+FF_GetScriptPath()+"\\Saver3.html",1,false);
 shell.Run(FF_GetScriptPath()+"\\Saver3.html",1,false);
}

function MakeExif()
{
    var r;
    OCtrlTop = 3;
    EDlg = new Dialog("Exif anlegen fr Datei: "+name, 200,55);

    EDlg.addControl("Datei:",   "STATIC",                               5, OCtrlTop, 30,   12);
    EDlg.addControl(name,       "STATIC",                               35, OCtrlTop, 130, 12); OCtrlTop+=10;
    EDlg.addControl("Dieses Bild besitzt keine EXIF-Daten",   "STATIC", 5, OCtrlTop, 180, 12); OCtrlTop+=10;
    EDlg.addControl("Soll nun ein EXIF Block angelegt werden","STATIC", 5, OCtrlTop, 180, 12); OCtrlTop+=10;
    OCtrlTop+=10;
    mabort = EDlg.addControl("&Abbruch",      "BUTTON", 50, OCtrlTop, 30, 12,0);
    mok    = EDlg.addControl("&EXIF anlegen", "BUTTON", 95, OCtrlTop, 60, 12,0);
    r =EDlg.Show();
    EDlg.Close();
    if ( r == mok.name )
     {
      FF_CreateExif();
      if( C_EditExifScript != "")
      {
        var sp=FF_getParam();
        FF_SetParam( escape(name) +" -NOSAVE");
        ff_CallScript(C_EditExifScript);
        FF_SetParam(sp);
      }
      FF_SaveExif(name);
      return 1;
     }
   return 0;

}

// liefert Verzeichnis mit abschlieendem Backslash,
// Dateinamen und Erweiterung mit einleitendem Punkt
function SplitPath(path)
{
 var result = new Object();
 result.dir = fso.GetParentFolderName(path) + "\\";
 result.file = fso.GetBaseName(path);
 result.ext = "." + fso.GetExtensionName(path);
 return result;
}

